<?php

function register_plugins() {
	global $plugin_array;

	$d = opendir( "./plugins" );

	if( !$d ) {
		echo( "Warning: directory plugins does not exist\n" );
	}

	while( $f = readdir($d) ) {
		if( $f == ".." || $f == "." ) {
			continue;
		}

		if( !preg_match( '/^(.*)\.php$/', $f, $name ) ) {
			continue;
		}

		$functionname = $name[1];

		echo( "Including $f\n" );

		include_once( "./plugins/$f" );
		
		$func = $functionname . "_register_plugins";
		$func();
	}

	closedir( $d );
}

function do_page_header_hooks( $page_data ) {
	global $plugin_array;
	global $exit_values;

	$keys = array_keys( $plugin_array );

	for( $i = 0; $i<sizeof( $keys ) ; $i++ ) {
		$plugin_name = $keys[$i];

		if( $plugin_array[$plugin_name]['header_hooks'] != NULL ) {
			$val = $page_data;

			$func = $plugin_array[$plugin_name]['header_hooks'];
			$ret = $func( &$val );

			echo( "Returned: $val\n" );

			switch( $ret ) {
				// now lets make the page_data = val
				case $exit_values['good_exit']: {
					$page_data = $val;
					break;
				}

				// now lets stop the further exection
				case $exit_values['done']: {
					$page_data = $val;
					return( $exit_values['done'] );
				}
			}
		}
	}
	return( $exit_values['good_exit'] );

}

function do_page_content_hooks( $page_data ) {
	global $plugin_array;
	global $exit_values;

	$keys = array_keys( $plugin_array );

	for( $i = 0; $i<sizeof( $keys ) ; $i++ ) {
		$plugin_name = $keys[$i];

		if( $plugin_array[$plugin_name]['content_hooks'] != NULL ) {
			$val = $page_data;

			$func = $plugin_array[$plugin_name]['content_hooks'];
			$ret = $func( &$val );

			echo( "Returned: $val\n" );

			switch( $ret ) {
				// now lets make the page_data = val
				case $exit_values['good_exit']: {
					$page_data = $val;
					break;
				}

				// now lets stop the further exection
				case $exit_values['done']: {
					$page_data = $val;
					return( $exit_values['done'] );
				}
			}
		}
	}
	return( $exit_values['good_exit'] );

}

function do_page_footer_hooks( $page_data ) {
	global $plugin_array;
	global $exit_values;

	$keys = array_keys( $plugin_array );

	for( $i = 0; $i<sizeof( $keys ) ; $i++ ) {
		$plugin_name = $keys[$i];

		if( $plugin_array[$plugin_name]['footer_hooks'] != NULL ) {
			$val = $page_data;

			$func = $plugin_array[$plugin_name]['footer_hooks'];
			$ret = $func( &$val );

			echo( "Returned: $val\n" );

			switch( $ret ) {
				// now lets make the page_data = val
				case $exit_values['good_exit']: {
					$page_data = $val;
					break;
				}

				// now lets stop the further exection
				case $exit_values['done']: {
					$page_data = $val;
					return( $exit_values['done'] );
				}
			}
		}
	}
	return( $exit_values['good_exit'] );
}

?>
